import 'dart:io';

import 'package:animate_do/animate_do.dart';
import 'package:assets_audio_player/assets_audio_player.dart';
import 'package:dialog_pp_flutter/in_app_purchase.dart';
import 'package:external_app_launcher/external_app_launcher.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter_rating_bar/flutter_rating_bar.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:get/get.dart';
import 'package:in_app_review/in_app_review.dart';
import 'package:in_app_update/in_app_update.dart';
import 'package:lottie/lottie.dart';
import 'package:motion_toast/motion_toast.dart';
import 'package:onesignal_flutter/onesignal_flutter.dart';
import 'package:package_info_plus/package_info_plus.dart';
import 'package:rounded_loading_button/rounded_loading_button.dart';
import 'package:scroll_loop_auto_scroll/scroll_loop_auto_scroll.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:url_launcher/url_launcher.dart';
import 'package:webview_flutter/webview_flutter.dart';

import 'get_controller.dart';
import 'model_class.dart';

class PPDialog {
  static updateDialog(BuildContext context,
      {required bool isUpdateRequired,
      required bool isPopup,
      required int apiVersionCode,
      required String appLogoApi,
      required String appNameApi,
      required String subtitleAppApi,
      required int adSettingAppVersionCode,
      required String appWebsiteUrl}) async {
    if ((isPopup == true && (apiVersionCode) > int.parse(AppDetailsPP.to.buildNumber.value))
        && int.parse(AppDetailsPP.to.buildNumber.value) != adSettingAppVersionCode) {

      AssetsAudioPlayer.newPlayer().open(
        Audio("packages/dialog_pp_flutter/assets/dialogs_assets/music.wav"),
        autoStart: true,
        showNotification: false,
      );

      Get.defaultDialog(
          onWillPop: () async {
            if (isUpdateRequired == true) {
              return false;
            } else {
              return true;
            }
          },
          barrierDismissible: isUpdateRequired == true ? false : true,
          title: "",
          content: Stack(
            children: [
              Column(
                children: [
                  Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: [
                      Align(
                        alignment: Alignment.topRight,
                        child: Lottie.asset(
                            "packages/dialog_pp_flutter/assets/dialogs_assets/bell.json",
                            height: 70.h),
                      ),
                      Text(
                        "Alert".tr,
                        style: TextStyle(
                            fontSize: 24.w, fontWeight: FontWeight.bold),
                      ),
                      const Text(
                        " (Ad)",
                        style: TextStyle(color: Colors.grey),
                      ),
                    ],
                  ),
                  const SizedBox(
                    height: 20,
                  ),
                  if (appLogoApi.isEmpty)
                    Container(
                      decoration: const BoxDecoration(
                          borderRadius: BorderRadius.all(Radius.circular(20))),
                      child: Container(
                        decoration: const BoxDecoration(
                            borderRadius:
                                BorderRadius.all(Radius.circular(20))),
                        child: Image.asset(
                          appLogoApi,
                          height: 250.h,
                        ),
                      ),
                    )
                  else
                    Container(
                      decoration: BoxDecoration(
                        borderRadius:
                            const BorderRadius.all(Radius.circular(30)),
                        boxShadow: [
                          BoxShadow(
                            color: Colors.black.withOpacity(0.3),
                            spreadRadius: 2,
                            blurRadius: 5,
                            offset: const Offset(
                                4, 10), // changes position of shadow
                          ),
                        ],
                      ),
                      child: ClipRRect(
                        borderRadius:
                            const BorderRadius.all(Radius.circular(30)),
                        child: InkWell(
                          onTap: () async {
                            DialogGetController.to.noThankButton.value = true;

                            var packageid = appWebsiteUrl.split("?id=");

                            await LaunchApp.openApp(
                                androidPackageName: packageid[1],
                                iosUrlScheme: 'pulsesecure://',
                                appStoreLink:
                                    'itms-apps://itunes.apple.com/us/app/pulse-secure/id945832041');
                            // launch(appWebsiteUrl);
                          },
                          child: Image.network(
                            appLogoApi,
                            fit: BoxFit.fill,
                            height: 190.h,
                            width: 190.h,
                          ),
                        ),
                      ),
                    ),
                ],
              ),
            ],
          ),
          actions: [
            Column(
              children: [
                SizedBox(
                  height: 20.h,
                ),
                Text(appNameApi.tr,
                    style: const TextStyle(
                        color: Colors.black, fontWeight: FontWeight.bold)),
                SizedBox(
                  height: 10.h,
                ),
                Text(subtitleAppApi.tr, textAlign: TextAlign.center),
                SizedBox(
                  height: 5.h,
                )
              ],
            )
          ],
          backgroundColor: Colors.white,
          titleStyle: const TextStyle(
              color: Colors.black, fontWeight: FontWeight.bold, height: 00),
          middleTextStyle: const TextStyle(
            color: Colors.white,
          ),
          confirm: Padding(
            padding: EdgeInsets.only(bottom: 10.h),
            child: Stack(
              children: [
                Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  crossAxisAlignment: CrossAxisAlignment.center,
                  children: [
                    isUpdateRequired == false
                        ? InkWell(
                            onTap: () {
                              Get.back();
                            },
                            child: Text(
                              "No Thanks".tr,
                              style: const TextStyle(
                                  color: Color(0xff007A3D),
                                  fontWeight: FontWeight.bold),
                            ),
                          )
                        : Obx(
                            () => DialogGetController.to.noThankButton.value ==
                                    true
                                ? Padding(
                                    padding: EdgeInsets.only(right: 30.w),
                                    child: InkWell(
                                      onTap: () {
                                        Get.back();
                                      },
                                      child: Text(
                                        "No Thanks".tr,
                                        style: const TextStyle(
                                            color: Color(0xff007A3D),
                                            fontWeight: FontWeight.bold),
                                      ),
                                    ),
                                  )
                                : Container(),
                          ),
                    SizedBox(
                      width: isUpdateRequired == true ? 0.w : 30.w,
                    ),
                    Container(
                      height: 50.h,
                      decoration: const BoxDecoration(
                        borderRadius: BorderRadius.all(Radius.circular(20)),
                      ),
                      width: 150.w,
                      child: Row(
                        children: [
                          InkWell(
                            child: Container(
                              width: 150.w,
                              height: 50.h,
                              decoration: const BoxDecoration(
                                image: DecorationImage(
                                  image: AssetImage(
                                      "packages/dialog_pp_flutter/assets/dialogs_assets/playstore.png"),
                                  fit: BoxFit.fitWidth,
                                  alignment: Alignment.topCenter,
                                ),
                              ),
                            ),
                            onTap: () async {
                              DialogGetController.to.noThankButton.value = true;

                              var packageid = appWebsiteUrl.split("?id=");

                              await LaunchApp.openApp(
                                  androidPackageName: packageid[1],
                                  iosUrlScheme: 'pulsesecure://',
                                  appStoreLink:
                                      'itms-apps://itunes.apple.com/us/app/pulse-secure/id945832041');
                            },
                          )
                        ],
                      ),
                    ),
                    SizedBox(
                      height: 20.h,
                    )
                  ],
                ),
              ],
            ),
          ),
          // confirm: Container(
          //   child: Text("Download App"),
          // ),
          radius: 10);
    }
  }

  static newVersionCode() async {
    WidgetsFlutterBinding.ensureInitialized();
    PackageInfo packageInfo = await PackageInfo.fromPlatform();
    AppDetailsPP.to.appName.value = packageInfo.appName;
    AppDetailsPP.to.packageName.value = packageInfo.packageName;
    AppDetailsPP.to.versionApp.value = packageInfo.version;
    AppDetailsPP.to.buildNumber.value = packageInfo.buildNumber;
  }

  static Future<void> autoUpdate() async {
    InAppUpdate.checkForUpdate().then((info) {}).catchError((e) {
      if (kDebugMode) {
        print(e.toString());
      }
    }).then((value) => {
          InAppUpdate.startFlexibleUpdate(),
        });
  }

  static autoRate() {
    final InAppReview inAppReview = InAppReview.instance;

    WidgetsBinding.instance.addPostFrameCallback((_) async {
      await inAppReview.isAvailable();
    });

    Future<void> _requestReview() => inAppReview.requestReview();
    _requestReview();
  }

  static drawerScreen(
      {required String appLogo,
      required String privacyPolicy,
      required String feedbackEmailId,
      required String emailSubject,
      required String emailMessage}) {
    late ScrollController scrollController = ScrollController();
    return Drawer(
        backgroundColor: Colors.transparent,
        width: 300.r,
        child: SafeArea(
          child: ClipRRect(
            borderRadius: BorderRadius.only(
                topRight: Radius.circular(20.r),
                bottomRight: Radius.circular(20.r)),
            child: Scaffold(
              backgroundColor: Colors.white,
              body: Padding(
                padding: EdgeInsets.symmetric(horizontal: 10.r),
                child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      Center(
                        child: Container(
                          height: 120.h,
                          width: 120.h,
                          decoration: BoxDecoration(
                              borderRadius:
                                  const BorderRadius.all(Radius.circular(20)),
                              border: Border.all()),
                          margin: EdgeInsets.only(top: 10.r, bottom: 10.r),
                          child: Image.asset(
                            appLogo,
                            fit: BoxFit.fill,
                          ),
                        ),
                      ),
                      Divider(color: Colors.black.withOpacity(0.75)),
                      InkWell(
                        splashColor: Colors.transparent,
                        highlightColor: Colors.transparent,
                        onTap: () {
                          // ignore: deprecated_member_use
                          launch(privacyPolicy);
                        },
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            SizedBox(
                                height: 25.h,
                                width: 25.h,
                                child: Image.asset(
                                  "packages/dialog_pp_flutter/assets/dialogs_assets/privacy.png",
                                  color: Colors.black,
                                )),
                            SizedBox(
                              width: 25.w,
                            ),
                            Text(
                              "Privacy Policy",
                              style: TextStyle(
                                fontWeight: FontWeight.w400,
                                color: Colors.black,
                                fontSize: 16.sp,
                              ),
                            ),
                            const Spacer()
                          ],
                        ),
                      ),
                      SizedBox(
                        height: 15.h,
                      ),
                      InkWell(
                        splashColor: Colors.transparent,
                        highlightColor: Colors.transparent,
                        onTap: () {
                          // ignore: deprecated_member_use
                          launch(
                              "$feedbackEmailId?subject=$emailSubject&body=$emailMessage");
                        },
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            Container(
                                height: 25.h,
                                width: 25.h,
                                padding: EdgeInsets.all(1.r),
                                child: Image.asset(
                                  "packages/dialog_pp_flutter/assets/dialogs_assets/feedback.png",
                                  color: Colors.black,
                                )),
                            SizedBox(
                              width: 25.w,
                            ),
                            Text(
                              "Feedback",
                              style: TextStyle(
                                fontWeight: FontWeight.w400,
                                color: Colors.black,
                                fontSize: 16.sp,
                              ),
                            ),
                            const Spacer()
                          ],
                        ),
                      ),
                      SizedBox(
                        height: 15.h,
                      ),
                      InkWell(
                        splashColor: Colors.transparent,
                        highlightColor: Colors.transparent,
                        onTap: () {
                          Future.delayed(const Duration(seconds: 0), () {
                            showAboutUs(Get.context!, appLogo);
                          });
                        },
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            SizedBox(
                                height: 25.h,
                                width: 25.h,
                                child: Image.asset(
                                    "packages/dialog_pp_flutter/assets/dialogs_assets/about.png",
                                    color: Colors.black)),
                            SizedBox(
                              width: 25.w,
                            ),
                            Text(
                              "About us",
                              style: TextStyle(
                                fontWeight: FontWeight.w400,
                                color: Colors.black,
                                fontSize: 16.sp,
                              ),
                            ),
                            const Spacer()
                          ],
                        ),
                      ),
                      Divider(color: Colors.black.withOpacity(0.75)),
                      moreLiveApp?.record.isNotEmpty == true
                          ? Expanded(
                              child: ScrollLoopAutoScroll(
                                scrollDirection: Axis.vertical,
                                enableScrollInput: true,
                                duration: const Duration(seconds: 120),
                                gap: 0,
                                reverseScroll: false,
                                child: ListView.builder(
                                  controller: scrollController,
                                  shrinkWrap: true,
                                  itemCount: moreLiveApp?.record.length,
                                  itemBuilder: (context, index) {
                                    String? packageNameFromJson =
                                        moreLiveApp?.record[index].links;
                                    String? fileName =
                                        packageNameFromJson?.replaceAll(
                                            "https://play.google.com/store/apps/details?id=",
                                            "");

                                    String? titleFinal;
                                    if (fileName ==
                                        AppDetailsPP.to.packageName.value) {
                                      titleFinal =
                                          moreLiveApp?.record[index].title;
                                    }

                                    return titleFinal !=
                                            moreLiveApp?.record[index].title
                                        ? InkWell(
                                            splashColor: Colors.transparent,
                                            highlightColor: Colors.transparent,
                                            onTap: () async {
                                              await LaunchApp.openApp(
                                                androidPackageName: fileName,
                                                iosUrlScheme: '',
                                              );
                                            },
                                            child: SizedBox(
                                              height: 70.h,
                                              child: Row(
                                                children: [
                                                  ClipRRect(
                                                    borderRadius:
                                                        BorderRadius.circular(
                                                            10.r),
                                                    child: SizedBox(
                                                      height: 60.h,
                                                      width: 60.h,
                                                      child: Image.network(
                                                        moreLiveApp!
                                                            .record[index]
                                                            .image,
                                                        loadingBuilder: (context,
                                                            child,
                                                            loadingProgress) {
                                                          if (loadingProgress ==
                                                              null) {
                                                            return child;
                                                          }
                                                          return Center(
                                                            child: SizedBox(
                                                              height: 20.h,
                                                              width: 20.h,
                                                              child:
                                                                  CircularProgressIndicator(
                                                                value: loadingProgress
                                                                            .expectedTotalBytes !=
                                                                        null
                                                                    ? loadingProgress
                                                                            .cumulativeBytesLoaded /
                                                                        loadingProgress
                                                                            .expectedTotalBytes!
                                                                    : null,
                                                              ),
                                                            ),
                                                          );
                                                        },
                                                      ),
                                                    ),
                                                  ),
                                                  SizedBox(
                                                    width: 10.w,
                                                  ),
                                                  Column(
                                                    mainAxisAlignment:
                                                        MainAxisAlignment
                                                            .center,
                                                    crossAxisAlignment:
                                                        CrossAxisAlignment
                                                            .start,
                                                    children: [
                                                      Row(
                                                        mainAxisAlignment:
                                                            MainAxisAlignment
                                                                .start,
                                                        children: [
                                                          SizedBox(
                                                            width: 160.w,
                                                            child: Text(
                                                              '${moreLiveApp!.record[index].title} ',
                                                              maxLines: 2,
                                                              style: TextStyle(
                                                                fontSize: 16.sp,
                                                                overflow:
                                                                    TextOverflow
                                                                        .ellipsis,
                                                                color: Colors
                                                                    .black,
                                                              ),
                                                            ),
                                                          ),
                                                          moreLiveApp!
                                                                      .record[
                                                                          index]
                                                                      .subtitle
                                                                      .isEmpty ==
                                                                  true
                                                              ? Text("(Ad)",
                                                                  style:
                                                                      TextStyle(
                                                                    fontSize:
                                                                        10.sp,
                                                                    overflow:
                                                                        TextOverflow
                                                                            .ellipsis,
                                                                    color: Colors
                                                                        .black38,
                                                                  ))
                                                              : const SizedBox(
                                                                  width: 0,
                                                                  height: 0,
                                                                )
                                                        ],
                                                      ),
                                                      moreLiveApp!
                                                                  .record[index]
                                                                  .subtitle
                                                                  .isNotEmpty ==
                                                              true
                                                          ? SizedBox(
                                                              height: 5.h,
                                                            )
                                                          : const SizedBox(
                                                              width: 0,
                                                              height: 0,
                                                            ),
                                                      moreLiveApp!
                                                                  .record[index]
                                                                  .subtitle
                                                                  .isNotEmpty ==
                                                              true
                                                          ? Row(
                                                              mainAxisAlignment:
                                                                  MainAxisAlignment
                                                                      .start,
                                                              children: [
                                                                SizedBox(
                                                                  width: 160.w,
                                                                  child: Text(
                                                                    moreLiveApp!
                                                                        .record[
                                                                            index]
                                                                        .subtitle,
                                                                    maxLines: 2,
                                                                    style:
                                                                        const TextStyle(
                                                                      overflow:
                                                                          TextOverflow
                                                                              .ellipsis,
                                                                      color: Colors
                                                                          .black38,
                                                                    ),
                                                                  ),
                                                                ),
                                                                moreLiveApp!
                                                                            .record[
                                                                                index]
                                                                            .subtitle
                                                                            .isNotEmpty ==
                                                                        true
                                                                    ? Text(
                                                                        "(Ad)",
                                                                        style:
                                                                            TextStyle(
                                                                          fontSize:
                                                                              10.sp,
                                                                          overflow:
                                                                              TextOverflow.ellipsis,
                                                                          color:
                                                                              Colors.black38,
                                                                        ))
                                                                    : const SizedBox(
                                                                        width:
                                                                            0,
                                                                        height:
                                                                            0,
                                                                      )
                                                              ],
                                                            )
                                                          : SizedBox(
                                                              height: 0.h,
                                                            ),
                                                    ],
                                                  ),
                                                ],
                                              ),
                                            ),
                                          )
                                        : const SizedBox(
                                            height: 0,
                                            child: Text("111111111111"));
                                  },
                                ),
                              ),
                            )
                          : const Text("102030102030"),
                    ]),
              ),
            ),
          ),
        ));
  }

  static Future<void> showAboutUs(BuildContext context, String logoApp) async {
    return showAboutDialog(
      context: context,
      applicationIcon: SizedBox(
        height: 100.sp,
        width: 100.sp,
        child: Image(
          image: AssetImage(logoApp),
          fit: BoxFit.contain,
          alignment: Alignment.bottomCenter,
        ),
      ),
      // s,
      // applicationLegalese: apiModel!.aboutApp!.registrationDetail,
      applicationName: AppDetailsPP.to.appName.value,
      applicationVersion: AppDetailsPP.to.buildNumber.value,
      children: <Widget>[
        Padding(
            padding: EdgeInsets.only(top: 5.h),
            child: Text(AppDetailsPP.to.packageName.value))
      ],
    );
  }

  static rateDialogCustom(BuildContext context, {required String logoApp}) {
    final RoundedLoadingButtonController btnController =
        RoundedLoadingButtonController();

    AssetsAudioPlayer.newPlayer().open(
      Audio("packages/dialog_pp_flutter/assets/dialogs_assets/review.mp3"),
      autoStart: true,
      showNotification: false,
    );
    showDialog(
        barrierDismissible: false,
        builder: (context) {
          return WillPopScope(
            onWillPop: () async {
              return false;
            },
            child: StatefulBuilder(
              builder: (BuildContext context, StateSetter setState) {
                return Dialog(
                    shape: RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(16.0)),
                    elevation: 0.0,
                    backgroundColor: Colors.transparent,
                    child: Container(
                      margin: const EdgeInsets.only(left: 0.0, right: 0.0),
                      child: Stack(
                        children: <Widget>[
                          Container(
                            padding: const EdgeInsets.only(
                              top: 25.0,
                            ),
                            margin: EdgeInsets.only(top: 60.h),
                            width: double.infinity,
                            decoration: BoxDecoration(
                                color: Colors.white,
                                shape: BoxShape.rectangle,
                                borderRadius: BorderRadius.circular(16.0),
                                boxShadow: const <BoxShadow>[
                                  BoxShadow(
                                    color: Colors.black26,
                                    blurRadius: 0.0,
                                    offset: Offset(0.0, 0.0),
                                  ),
                                ]),
                            child: Column(
                              mainAxisSize: MainAxisSize.min,
                              children: [
                                SizedBox(
                                  height: 30.h,
                                ),
                                ElasticIn(
                                  child: Text(
                                    "Rating Dialog",
                                    style: TextStyle(
                                        fontWeight: FontWeight.bold,
                                        fontSize: 20.w),
                                  ),
                                ),
                                SizedBox(
                                  height: 10.h,
                                ),
                                ElasticIn(
                                  child: Container(
                                    height: 100.h,
                                    width: 100.h,
                                    decoration: BoxDecoration(
                                      // border: Border.all(),
                                      borderRadius: const BorderRadius.all(
                                          Radius.circular(10)),
                                      image: DecorationImage(
                                          image: AssetImage(logoApp),
                                          fit: BoxFit.fill),
                                      boxShadow: [
                                        BoxShadow(
                                          color: Colors.black.withOpacity(0.2),
                                          spreadRadius: 2,
                                          blurRadius: 5,
                                          offset: const Offset(4,
                                              10), // changes position of shadow
                                        ),
                                      ],
                                    ),
                                  ),
                                ),
                                SizedBox(
                                  height: 20.w,
                                ),
                                ElasticIn(
                                  child: Text(
                                      "Tap a star to set your rating. Add more description here if you want.",
                                      textAlign: TextAlign.center,
                                      style: TextStyle(fontSize: 15.w)),
                                ),
                                SizedBox(
                                  height: 15.w,
                                ),
                                ElasticIn(
                                  child: RatingBar.builder(
                                    initialRating: 5,
                                    minRating: 1,
                                    updateOnDrag: true,
                                    glow: true,
                                    glowRadius: 0.5,
                                    itemSize: 40.w,
                                    maxRating: 5,
                                    direction: Axis.horizontal,
                                    allowHalfRating: false,
                                    itemCount: 5,
                                    itemPadding: const EdgeInsets.symmetric(
                                        horizontal: 4.0),
                                    itemBuilder: (context, _) => const Icon(
                                      Icons.star,
                                      color: Colors.amber,
                                    ),
                                    onRatingUpdate: (rating) {
                                      DialogGetController.to.emojiCount.value =
                                          int.parse(rating.toStringAsFixed(0));
                                    },
                                  ),
                                ),
                                SizedBox(
                                  height: 15.w,
                                ),
                                Padding(
                                  padding:
                                      EdgeInsets.only(left: 30.w, right: 30.w),
                                  child: ElasticIn(
                                    child: RoundedLoadingButton(
                                      successColor: Colors.green,
                                      animateOnTap: true,
                                      controller: btnController,
                                      onPressed: () {
                                        Future.delayed(
                                            const Duration(milliseconds: 500),
                                            () {
                                          btnController.success();

                                          Future.delayed(
                                              const Duration(milliseconds: 300),
                                              () {
                                            if (DialogGetController
                                                    .to.emojiCount.value >=
                                                3) {
                                              Get.back();

                                              // ignore: deprecated_member_use
                                              launch(
                                                  "https://play.google.com/store/apps/details?id=${AppDetailsPP.to.packageName}");

                                              Future.delayed(
                                                  const Duration(
                                                      milliseconds: 200), () {
                                                DialogGetController
                                                    .to.emojiCount.value = 5;
                                              });
                                            } else {
                                              Get.back();
                                              MotionToast.success(
                                                      height: 60.h,
                                                      title: const Text(
                                                          "Thanks For Your Rating"),
                                                      description: const Text(
                                                          "We Will Improve App"),
                                                      width: 300)
                                                  .show(Get.context!);
                                              DialogGetController
                                                  .to.emojiCount.value = 5;
                                            }
                                          });
                                        });
                                        // Get.back();
                                      },
                                      child: Text('SUBMIT',
                                          style: TextStyle(
                                              color: Colors.white,
                                              fontSize: 15.w)),
                                    ),
                                  ),
                                ),
                                SizedBox(
                                  height: 20.h,
                                )
                              ],
                              // mainAxisSize: MainAxisSize.min,
                            ),
                          ),
                          Positioned(
                            right: 0,
                            left: 0,
                            child: GestureDetector(
                              onTap: () {
                                Navigator.of(context).pop();
                              },
                              child: Align(
                                  alignment: Alignment.center,
                                  child: Container(
                                      padding: EdgeInsets.all(10.h),
                                      decoration: const BoxDecoration(
                                        color: Colors.white,
                                        shape: BoxShape.circle,
                                      ),
                                      child: Obx(
                                        () => ElasticIn(
                                          child: Image.asset(
                                            gaplessPlayback: true,
                                            "packages/dialog_pp_flutter/assets/dialogs_assets/${DialogGetController.to.emojiCount.value} star.png",
                                            height: 80.h,
                                          ),
                                        ),
                                      ))),
                            ),
                          ),
                          Positioned(
                            right: 0,
                            child: InkWell(
                                onTap: () {
                                  Get.back();
                                  DialogGetController.to.emojiCount.value = 5;
                                },
                                child: Container(
                                    margin: EdgeInsets.only(top: 60.h),
                                    padding: EdgeInsets.all(5.h),
                                    decoration: BoxDecoration(
                                        color: Colors.red[500],
                                        border: Border.all(color: Colors.white),
                                        borderRadius: const BorderRadius.all(
                                            Radius.circular(10))),
                                    child: const Icon(
                                      Icons.close,
                                      color: Colors.white,
                                    ))),
                          )
                        ],
                      ),
                    ));
              },
            ),
          );
        },
        context: context);
  }

  static rewardDialog(
      {required String rewardMessage, required GestureTapCallback onTap}) {
    return showDialog(
      context: Get.context!,
      builder: (context) {
        return SimpleDialog(
          contentPadding: EdgeInsets.zero,
          insetPadding: EdgeInsets.zero,
          backgroundColor: Colors.transparent,
          title: Container(
            decoration: const BoxDecoration(
                borderRadius: BorderRadius.all(Radius.circular(20)),
                color: Colors.white),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: [
                Align(
                    alignment: Alignment.topRight,
                    child: Padding(
                        padding: EdgeInsets.only(right: 20.w, top: 10.h),
                        child: InkWell(
                            onTap: () {
                              Get.back();
                            },
                            child: const Icon(Icons.close)))),
                Padding(
                  padding: EdgeInsets.only(left: 20.w, right: 20.w, top: 20.h),
                  child: Image.asset(
                      "packages/dialog_pp_flutter/assets/dialogs_assets/reward.png",
                      gaplessPlayback: true,
                      height: 120.h),
                ),
                SizedBox(
                  height: 20.h,
                ),
                Text(
                  "Reward Ad",
                  style: TextStyle(
                      fontWeight: FontWeight.bold,
                      color: Colors.grey,
                      fontSize: 25.w),
                ),
                SizedBox(
                  height: 15.h,
                ),
                Padding(
                  padding: EdgeInsets.only(left: 10.w, right: 10.w),
                  child: Text(
                    rewardMessage,
                    style: TextStyle(
                        color: const Color(0xffA1A1A1), fontSize: 15.w),
                    textAlign: TextAlign.center,
                  ),
                ),
                SizedBox(
                  height: 20.h,
                ),
                InkWell(
                  onTap: onTap,
                  child: Container(
                    decoration: BoxDecoration(
                        boxShadow: [
                          BoxShadow(
                              color: Colors.black.withOpacity(0.20),
                              blurRadius: 8.0,
                              offset: const Offset(0, 10))
                        ],
                        borderRadius:
                            const BorderRadius.all(Radius.circular(10)),
                        color: const Color(0xff5291CC)),
                    padding:
                        EdgeInsets.symmetric(horizontal: 40.w, vertical: 10.h),
                    child: Text(
                      "Watch Ad",
                      style: TextStyle(
                          color: Colors.white,
                          fontWeight: FontWeight.bold,
                          fontSize: 20.w),
                    ),
                  ),
                ),
                SizedBox(
                  height: 20.h,
                ),
              ],
            ),
          ),
        );
      },
    );
  }

  static exitDialog({
    Widget? mediumNative,
    required String appLogo,
    Color yesButtonColor = Colors.white,
    yesButtonTextColor = Colors.black,
    Color noButtonColor = Colors.black,
    Color noButtonTextColor = Colors.white,
    Color noButtonBorderColor = Colors.black,
    Color yesButtonBorderColor = Colors.black,
  }) {
    return showDialog(
        builder: (context) {
          return WillPopScope(
            onWillPop: () async {
              return true;
            },
            child: Dialog(
                shape: RoundedRectangleBorder(
                    borderRadius: BorderRadius.circular(20.h)),
                elevation: 0.0,
                backgroundColor: Colors.transparent,
                child: Stack(
                  children: <Widget>[
                    Container(
                      margin: const EdgeInsets.only(top: 50.0),
                      padding: EdgeInsets.only(top: 30.r),
                      decoration: BoxDecoration(
                        color: Colors.white,
                        borderRadius: BorderRadius.circular(20.h),
                      ),
                      child: SizedBox(
                        width: double.infinity,
                        child: Column(
                            crossAxisAlignment: CrossAxisAlignment.center,
                            mainAxisSize: MainAxisSize.min,
                            children: [
                              SizedBox(height: 15.h),
                              ElasticIn(
                                child: Center(
                                  child: Container(
                                    height: 120.h,
                                    width: 120.h,
                                    decoration: BoxDecoration(
                                        borderRadius: const BorderRadius.all(
                                            Radius.circular(20)),
                                        border: Border.all()),
                                    margin: EdgeInsets.only(
                                        top: 10.r, bottom: 10.r),
                                    child: Image.asset(
                                      appLogo,
                                      fit: BoxFit.fill,
                                    ),
                                  ),
                                ),
                              ),
                              SizedBox(height: 15.h),
                              ElasticIn(
                                child: Text(
                                  'Do You Want To Exit..?',
                                  style: TextStyle(
                                      fontFamily: 'JostBold', fontSize: 22.sp),
                                ),
                              ),
                              SizedBox(height: 15.h),
                              Row(
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceEvenly,
                                children: [
                                  InkWell(
                                    onTap: () {
                                      exit(0);
                                    },
                                    child: ElasticIn(
                                      child: Container(
                                        width: 120.w,
                                        height: 40.w,
                                        margin: EdgeInsets.all(3.h),
                                        alignment: Alignment.center,
                                        decoration: BoxDecoration(
                                            color: yesButtonColor,
                                            border: Border.all(
                                                color: yesButtonBorderColor),
                                            borderRadius:
                                                BorderRadius.circular(10.h)),
                                        child: Text(
                                          "Yes",
                                          style: TextStyle(
                                              fontSize: 18.sp,
                                              color: yesButtonTextColor,
                                              fontFamily: 'Jost'),
                                        ),
                                      ),
                                    ),
                                  ),
                                  InkWell(
                                    onTap: () {
                                      Get.back();
                                    },
                                    child: ElasticIn(
                                      child: Container(
                                        width: 120.w,
                                        height: 40.w,
                                        margin: EdgeInsets.all(3.h),
                                        alignment: Alignment.center,
                                        decoration: BoxDecoration(
                                            color: noButtonColor,
                                            border: Border.all(
                                                color: noButtonBorderColor),
                                            borderRadius: BorderRadius.all(
                                                Radius.circular(10.h))),
                                        child: Text('No',
                                            style: TextStyle(
                                                color: noButtonTextColor,
                                                fontFamily: 'Jost',
                                                fontSize: 19.sp)),
                                      ),
                                    ),
                                  )
                                ],
                              ),
                              SizedBox(height: 25.h),
                              ElasticIn(
                                child: Padding(
                                  padding: EdgeInsets.all(0.01.sh),
                                  child: mediumNative,
                                ),
                              )
                            ]),
                      ),
                    ),
                  ],
                )),
          );
        },
        context: Get.context!);
  }

  static termsConditions(BuildContext context,
      {required String privacyPolicyUrl,
      required String termsConditionUrl,
      required bool isPrivacyPolicy}) async {
    SharedPreferences pref = await SharedPreferences.getInstance();

    var checkTerms = pref.getBool("privacy") ?? false;

    if (isPrivacyPolicy == true) {
      if (checkTerms == false) {
        return showDialog(
          barrierDismissible: false,
          context: context,
          builder: (context) {
            return WillPopScope(
              onWillPop: () async {
                return false;
              },
              child: StatefulBuilder(
                  builder: (BuildContext context, StateSetter setState) {
                String smallString = termsConditionUrl.substring(
                    0, 4); //<-- this string will be abcde
                return SimpleDialog(
                  backgroundColor: Colors.transparent,
                  insetPadding: EdgeInsets.zero,
                  contentPadding: EdgeInsets.zero,
                  children: [
                    Container(
                      margin: EdgeInsets.all(20.h),
                      decoration: const BoxDecoration(
                          color: Colors.white,
                          borderRadius: BorderRadius.all(Radius.circular(15))),
                      child: Column(
                        mainAxisAlignment: MainAxisAlignment.start,
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: [
                          Container(
                            width: double.infinity,
                            height: 55.h,
                            decoration: const BoxDecoration(
                                color: Colors.red,
                                borderRadius: BorderRadius.only(
                                    topRight: Radius.circular(15),
                                    topLeft: Radius.circular(15))),
                            alignment: Alignment.center,
                            child: Text(
                              "Terms & Condition",
                              style: TextStyle(
                                  fontWeight: FontWeight.bold,
                                  color: Colors.white,
                                  fontSize: 20.w),
                            ),
                          ),
                          Padding(
                            padding: EdgeInsets.all(10.h),
                            child: SingleChildScrollView(
                              child: Column(
                                mainAxisAlignment: MainAxisAlignment.start,
                                crossAxisAlignment: CrossAxisAlignment.start,
                                children: [
                                  Padding(
                                    padding: EdgeInsets.all(10.h),
                                    child: smallString != "http"
                                        ? Padding(
                                            padding: const EdgeInsets.all(1),
                                            child: Column(
                                              mainAxisSize: MainAxisSize.min,
                                              children: [
                                                Text("${termsConditionUrl}")
                                              ],
                                            ),
                                          )
                                        : SizedBox(
                                            height: 350.h,
                                            child: Stack(
                                              children: [
                                                WebView(
                                                  onPageFinished: (finish) {},
                                                  javascriptMode: JavascriptMode
                                                      .unrestricted,
                                                  initialUrl: termsConditionUrl,
                                                ),
                                              ],
                                            ),
                                          ),
                                  ),
                                  Row(
                                    children: [
                                      Obx(
                                        () => Checkbox(
                                          value: DialogGetController
                                              .to.privacyCheck2.value,
                                          onChanged: (value) {
                                            DialogGetController.to.privacyCheck2
                                                .value = value!;
                                          },
                                          activeColor: Colors.green,
                                        ),
                                      ),
                                      Text.rich(
                                        TextSpan(
                                          children: [
                                            TextSpan(
                                                text: '    Agree',
                                                style: TextStyle(
                                                    color: Colors.black
                                                        .withOpacity(0.6))),
                                            const TextSpan(
                                                text:
                                                    ' Terms and Conditions    '),
                                          ],
                                        ),
                                      )
                                    ],
                                  ),
                                  Row(
                                    children: [
                                      Obx(
                                        () => Checkbox(
                                          activeColor: Colors.green,
                                          value: DialogGetController
                                              .to.privacyCheck1.value,
                                          onChanged: (value) {
                                            DialogGetController.to.privacyCheck1
                                                .value = value!;
                                          },
                                        ),
                                      ),
                                      InkWell(
                                          onTap: () {
                                            launch(privacyPolicyUrl);
                                          },
                                          child: Text.rich(
                                            TextSpan(
                                              children: [
                                                TextSpan(
                                                    text: '    Agree',
                                                    style: TextStyle(
                                                        color: Colors.black
                                                            .withOpacity(0.6))),
                                                const TextSpan(
                                                    text: ' Privacy Policy    ',
                                                    style: TextStyle(
                                                        decoration:
                                                            TextDecoration
                                                                .underline,
                                                        color: Colors.blue)),
                                              ],
                                            ),
                                          ))
                                    ],
                                  ),
                                  InkWell(
                                      onTap: () async {
                                        if (DialogGetController
                                                    .to.privacyCheck1.value ==
                                                true &&
                                            DialogGetController
                                                    .to.privacyCheck2.value ==
                                                true) {
                                          SharedPreferences pref =
                                              await SharedPreferences
                                                  .getInstance();
                                          await pref.setBool("privacy", true);
                                          await pref.setBool("terms", true);

                                          Navigator.pop(context);
                                        } else {}
                                      },
                                      child: Obx(
                                        () => Container(
                                          padding: EdgeInsets.all(10.h),
                                          margin: EdgeInsets.only(
                                              left: 80.r,
                                              right: 80.r,
                                              top: 10.h,
                                              bottom: 10.h),
                                          alignment: Alignment.center,
                                          decoration: BoxDecoration(
                                            color: DialogGetController
                                                            .to
                                                            .privacyCheck1
                                                            .value ==
                                                        true &&
                                                    DialogGetController
                                                            .to
                                                            .privacyCheck2
                                                            .value ==
                                                        true
                                                ? Colors.green
                                                : Colors.grey,
                                            borderRadius:
                                                const BorderRadius.all(
                                                    Radius.circular(10)),
                                          ),
                                          child: Text(
                                            "Agree",
                                            style: TextStyle(
                                                fontSize: 21.r,
                                                fontWeight: FontWeight.bold,
                                                color: Colors.white),
                                          ),
                                        ),
                                      ))
                                ],
                              ),
                            ),
                          )
                        ],
                      ),
                    ),
                  ],
                );
              }),
            );
          },
        );
      }
    }
  }

  static Future<void> oneSignalNotification(
      {required String? oneSignalId}) async {
    OneSignal.shared.setAppId("$oneSignalId");
    OneSignal.shared
        .promptUserForPushNotificationPermission()
        .then((accepted) {});
  }

  static inAppPurchase(
      {required Function onComplete,
      required Function onError,
      required String productId}) {
    showModalBottomSheet(
        context: Get.context!,
        builder: (BuildContext bc) {
          return SizedBox(
            height: 250.h,
            child: GoogleInAppPurchase(onComplete, onError),
          );
        });
  }
}
